SystemOrganization addCategory: #'Xtreams-ParsingTests'!

TestCase subclass: #PEGParserBootstrapTest
	instanceVariableNames: 'parser result rule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-ParsingTests'!

!PEGParserBootstrapTest methodsFor: 'initialize-release' stamp: 'nice 1/14/2011 23:18'!
setUp
	parser := PEGParser parserBootstrap! !

!PEGParserBootstrapTest methodsFor: 'testing' stamp: 'nice 1/14/2011 23:18'!
testParsePEG
	self assert: (parser parse: 'Grammar' stream: PEGParser grammarPEG reading positioning actor: nil) notEmpty.
	self assert: (parser parse: 'Grammar' stream: PEGParser grammarPEG reading positioning actor: PEGParserParser new) grammar size = 52! !

!PEGParserBootstrapTest methodsFor: 'testing' stamp: 'nice 1/14/2011 23:19'!
testParsePEGwithPEG
	parser := parser parse: 'Grammar' stream: PEGParser grammarPEG reading positioning actor: PEGParserParser new.
	self testParsePEG! !

!PEGParserBootstrapTest methodsFor: 'testing' stamp: 'nice 1/14/2011 23:19'!
testValidatePEG
	self assert: (parser validate: 'Grammar' stream: PEGParser grammarPEG reading positioning)! !

TestCase subclass: #PEGParserPEGTest
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-ParsingTests'!

!PEGParserPEGTest methodsFor: 'initialize-release' stamp: 'nice 1/14/2011 23:20'!
setUp
	parser := PEGParser parserPEG! !

!PEGParserPEGTest methodsFor: 'tests' stamp: 'nice 1/14/2011 23:21'!
testParsePEG
	self assert: (parser parse: 'Grammar' stream: PEGParser grammarPEG reading positioning actor: nil) notEmpty.
	self assert: (parser parse: 'Grammar' stream: PEGParser grammarPEG reading positioning actor: PEGParserParser new) grammar size = 52! !

!PEGParserPEGTest methodsFor: 'tests' stamp: 'nice 1/14/2011 23:21'!
testParsePEGwithPEG
	parser := parser parse: 'Grammar' stream: PEGParser grammarPEG reading positioning actor: PEGParserParser new.
	self testParsePEG! !

!PEGParserPEGTest methodsFor: 'tests' stamp: 'nice 1/14/2011 23:21'!
testValidatePEG
	self assert: (parser validate: 'Grammar' stream: PEGParser grammarPEG reading positioning)! !

TestCase subclass: #PEGParserSmalltalkTest
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-ParsingTests'!

!PEGParserSmalltalkTest methodsFor: 'initialize-release' stamp: 'nice 1/14/2011 23:22'!
setUp
	parser := PEGParser parserPEG parse: 'Grammar' stream: PEGParser grammarSmalltalk actor: PEGParserParser new.! !

!PEGParserSmalltalkTest methodsFor: 'testing' stamp: 'nice 1/14/2011 23:28'!
testBlockExpression

	<timeout: 10 "seconds">
	| expression tree |
	expression := '[super ++ (anInteger - skipped)] on: Incomplete do: [ :ex | ex pass ]'.
	tree := parser parse: 'Expression' stream: expression reading actor: PEGTreeBuilder new.
	tree key value size = expression size! !

!PEGParserSmalltalkTest methodsFor: 'testing' stamp: 'nice 1/14/2011 23:28'!
testExpressionKeywordMessageWithComplexArguments

	<timeout: 10 "seconds">
	| expression tree |
	expression := 'aSequenceableCollection replaceFrom: startIndex to: startIndex + tail - 1 with: cache startingAt: read + 1'.
	tree := parser parse: 'Method' stream: expression reading actor: PEGTreeBuilder new.
	tree key value size = expression size! !

!PEGParserSmalltalkTest methodsFor: 'testing' stamp: 'nice 1/14/2011 23:28'!
testMethodDoubleDashSelector

	<timeout: 10 "seconds">
	| expression tree |
	expression := '-- count	^count'.
	tree := parser parse: 'Method' stream: expression reading actor: PEGTreeBuilder new.
	tree key value size = expression size! !

TestCase subclass: #XTNumberParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-ParsingTests'!

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 15:43'!
testAA
	| number parser |
	parser := XTNumberParser new.
	number := parser parse: 'aa' base: 16.
	self assert: number = 170
	! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 17:12'!
testClassParse
	| number |
	number := XTNumberParser parse: '123'.
	self assert: number = 123! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 17:12'!
testClassParseBase
	| number |
	number := XTNumberParser parse: '123' base: 8..
	self assert: number = 83! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 17:13'!
testClassParseBaseFail
	| number |
	number := XTNumberParser parse: 'zz123' base: 8 ifFail: [25].
	self assert: number = 25! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 17:14'!
testClassParseBaseIfFail
	| number |
	number := XTNumberParser parse: '123' base: 8 ifFail: [25].
	self assert: number = 83! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 17:11'!
testDecimalFail
	| number parser |
	parser := XTNumberParser new.
	number := parser parse: '1.g23' ifFail: [99].
	self assert: number = 99! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 15:51'!
testFailBlock
	| parser result |
	parser := XTNumberParser new.
	result := parser parse: 'abc' ifFail: [42].
	self assert: result = 42.! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 15:44'!
testMinusOne
	| number parser |
	parser := XTNumberParser new.
	number := parser parse: '-1'.
	self assert: number = -1! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 17:11'!
testNilIfFail
	| number parser |
	parser := XTNumberParser new.
	number := parser parse: 'ccc'.
	self assert: number isNil! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 17:11'!
testNilIfFailBase8
	| number parser |
	parser := XTNumberParser new.
	number := parser parse: 'ccc' base: 8.
	self assert: number isNil! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 15:45'!
testOctal
	| number parser |
	parser := XTNumberParser new.
	number := parser parse: '70' base: 8.
	self assert: number = 56
	
! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 15:46'!
testOne
	| number parser |
	parser := XTNumberParser new.
	number := parser parse: '1'.
	self assert: number = 1! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 16:44'!
testOnePointTwo
	| number parser |
	parser := XTNumberParser new.
	number := parser parse: '1.2'.
	self assert: number = 1.2s1! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 17:00'!
testOnePointTwoThree
	| number parser |
	parser := XTNumberParser new.
	number := parser parse: '1.23'.
	self assert: number = 1.23s2! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 15:46'!
testOneTwentyThree
	| number parser |
	parser := XTNumberParser new.
	number := parser parse: '123'.
	self assert: number = 123! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 15:55'!
testParseBaseFail
	| parser result |
	parser := XTNumberParser new.
	result := parser parse: 'ccc' base: 12 ifFail: [42].
	self assert: result = 42.! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 15:52'!
testParseBaseIfFail
	| parser result |
	parser := XTNumberParser new.
	result := parser parse: '13' base: 12 ifFail: [42].
	self assert: result = 15.! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 15:46'!
testTwelve
	| number parser |
	parser := XTNumberParser new.
	number := parser parse: '12'.
	self assert: number = 12! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 15:46'!
testTwelveSpace
	| number parser |
	parser := XTNumberParser new.
	number := parser parse: '12'.
	self assert: number = 12! !

!XTNumberParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 15:47'!
testTwo
	| number parser |
	parser := XTNumberParser new.
	number := parser parse: '2'.
	self assert: number = 2! !

TestCase subclass: #XTNumberPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-ParsingTests'!

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 21:41'!
printWith: aBlock
	| printer stream |
	printer := XTNumberPrinter new.
	stream := String new writing.
	aBlock value: printer value: stream.
	^ stream conclusion.
	! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 22:19'!
testAA
	| result |
	result := self printWith: [:printer :stream | printer print: 170 on: stream base: 16].
	self assert: result = 'aa'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/15/2011 15:13'!
testDecimalPlaces
	| result |
	result := self printWith: 
		[:printer :stream | 
		printer decimalPlaces: 12.
		printer print: 11/7 on: stream].
	self assert: result = '1.571428571428'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/15/2011 14:15'!
testExtraZeros
	| result |
	result := self printWith: 
		[:printer :stream | 
		printer print: 1.23s7 on: stream].
	self assert: result = '1.2300000'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/15/2011 15:14'!
testFloat
	| result |
	result := self printWith: 
		[:printer :stream | 
		printer print: 1.5 on: stream].
	self assert: result = '1.5'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/15/2011 13:49'!
testFortyFivePointSix
	| result |
	result := self printWith: [:printer :stream | printer print: 45.6s1 on: stream].
	self assert: result = '45.6'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/15/2011 15:10'!
testFraction
	| result |
	result := self printWith:
		[:printer :stream | 
		printer print: 3/2 on: stream].
	self assert: result = '1.5'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/15/2011 14:32'!
testInfiniteFraction
	| result |
	result := self printWith:
		[:printer :stream | 
		printer print: 1/3 on: stream].
	self assert: result = '0.33333333'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 22:12'!
testMinusOne
	| result |
	result := self printWith: [:printer :stream | printer print: -1 on: stream].
	self assert: result = '-1'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 22:16'!
testOctal
	| result |
	result := self printWith: [:printer :stream | printer print: 56 on: stream base: 8].
	self assert: result = '70'.! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 21:40'!
testOne
	| result |
	result := self printWith: [:printer :stream | printer print: 1 on: stream].
	self assert: result = '1'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/15/2011 15:06'!
testOnePaddedWithSpace
	| result |
	result := self printWith:
		[:printer :stream | 
		printer padTo: 3 with: Character space.
		printer print: 1 on: stream].
	self assert: result = '  1'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 22:45'!
testOnePointTwo
	| result |
	result := self printWith: [:printer :stream | printer print: 1.2s1 on: stream].
	self assert: result = '1.2'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/15/2011 13:50'!
testOnePointTwoThree
	| result |
	result := self printWith: [:printer :stream | printer print: 1.23s2 on: stream].
	self assert: result = '1.23'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 22:00'!
testOneTwentyThree
	| result |
	result := self printWith: [ :printer :out | printer print: 123 on: out ].
	self assert: result = '123'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/15/2011 15:06'!
testSevenPaddedWithZero
	| result |
	result := self printWith: 
		[:printer :stream | 
		printer padTo: 3 with: $0.
		printer print: 7 on: stream base: 8].
	self assert: result = '007'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/15/2011 15:05'!
testTooWide
	| result |
	result := self printWith: 
		[:printer :stream | 
		printer padTo: 3 with: $x.
		printer print: 1.23s2 on: stream].
	self assert: result = '1.23'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 21:46'!
testTwelve
	| result |
	result := self printWith: [ :printer :out | printer print: 12 on: out ].
	self assert: result = '12'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 21:40'!
testTwo
	| result |
	result := self printWith: [ :printer :out | printer print: 2 on: out ].
	self assert: result = '2'! !

!XTNumberPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/15/2011 15:08'!
testZero
	| result |
	result := self printWith: [:printer :stream | printer print: 0 on: stream].
	self assert: result = '0'! !

PEGActor subclass: #PEGTreeBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-ParsingTests'!

!PEGTreeBuilder methodsFor: 'initialize-release' stamp: 'nice 1/14/2011 23:24'!
process: name object: object start: start stop: stop

	^(name -> (start + 1 to: stop)) -> object! !
